Index: ode/demo/demo_lmplus.cpp
===================================================================
--- ode/demo/demo_lmplus.cpp	(revision 0)
+++ ode/demo/demo_lmplus.cpp	(working copy)
@@ -0,0 +1,486 @@
+/*************************************************************************
+ * LMPlus demo, written for the                                          *
+ * Open Dynamics Engine, Copyright (C) 2001,2002 Russell L. Smith.       *
+ * All rights reserved.  Email: russ@q12.org   Web: www.q12.org          *
+ *                                                                       *
+ *   This demo was built from demo_chain1.c                              *
+ *   Content novel to this file Copyright 2012, Joseph Cooper            *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *                                                                       *
+ * Novel material in this file can also, at your option, be distributed  *
+ * under the ZLib license,                                               *
+ * see http://www.gzip.org/zlib/zlib_license.html                        *
+ *                                                                       *
+ * This library is distributed in the hope that it will be useful,       *
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
+ * LICENSE.TXT and LICENSE-BSD.TXT for more details.                     *
+ *                                                                       *
+ *************************************************************************/
+/* exercise the C interface */
+
+#include <stdio.h>
+#include "ode/ode.h"
+#include "drawstuff/drawstuff.h"
+#include "texturepath.h"
+
+
+#ifdef _MSC_VER
+#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
+#endif
+
+/* select correct drawing functions */
+
+#ifdef dDOUBLE
+#define dsDrawBox dsDrawBoxD
+#define dsDrawSphere dsDrawSphereD
+#define dsDrawCylinder dsDrawCylinderD
+#define dsDrawCapsule dsDrawCapsuleD
+#define dsDrawLine dsDrawLineD
+#endif
+
+
+/* some constants */
+#define DNUM 4     /* number of dominoes */
+#define S5NUM (3)  /* Bodies in the sphere volume */
+#define S4NUM (3)  /* Bodies in the cylinder volume */
+#define S3NUM (3)  /* Bodies in the box volume */
+#define S2NUM (3)  /* Bodies in the plane */
+#define S1NUM (1)  /* Bodies on the line */
+#define SNUM (S5NUM + S4NUM + S3NUM + S2NUM + S1NUM)	/* number of spheres */
+#define RADIUS (0.15f)	/* sphere radius */
+#define DENSITY (1000.0f) 
+
+/* dynamics and collision objects */
+static dWorldID world;
+static dSpaceID space;
+static dJointGroupID contactgroup;
+
+/* A wandering kinematic sphere */
+static dBodyID kSphereBody;
+static dReal kSphereDim = 0.5;
+static dVector3 kSphereOrigin = {-1,-4,3};
+
+/* A spinning kinematic cylinder */
+static dBodyID cylBody;
+static dReal cylDim[2] = {2,0.5};
+static dVector3 cylOrigin = {4,-2,3};
+
+/* A spinning kinematic box */
+static dBodyID boxBody;
+static dReal boxDim[3] = {2,2,2};
+
+/* A rotating kinematic 'plane' */
+static dBodyID planeBody;
+static dReal planeDim[3] = {2,2,.05};
+
+/* Flippers that can push balls around */
+static dBodyID dominoBody[DNUM];
+static dReal domDim[3] = {.05,.4,.8};
+
+/* A bunch of balls */
+static dBodyID sphereBody[SNUM];
+static dJointID sJoint[SNUM];
+
+
+/* this is called by dSpaceCollide when two objects in space are
+ * potentially colliding.
+ */
+
+static void nearCallback (void *data, dGeomID o1, dGeomID o2)
+{
+  /* exit without doing anything if the two bodies are connected by a joint */
+  dBodyID b1,b2;
+  dContact contact;
+
+  b1 = dGeomGetBody(o1);
+  b2 = dGeomGetBody(o2);
+  /* Even if objects are connected by a genLinear, we still
+     want them to collide */
+  if (b1 && b2 && dAreConnectedExcluding( b1,b2,dJointTypeLMPlus)) return;
+
+  contact.surface.mode = 0;
+  contact.surface.mu = 0.1;
+  contact.surface.mu2 = 0;
+  if (dCollide (o1,o2,1,&contact.geom,sizeof(dContactGeom))) {
+    dJointID c = dJointCreateContact (world,contactgroup,&contact);
+    dJointAttach (c,b1,b2);
+  }
+}
+
+
+/* start simulation - set viewpoint */
+
+static void start()
+{
+  static float xyz[3] = {2.1640f,-5.3079f,2.7600f};
+  static float hpr[3] = {110.0000f,0.0000f,0.0000f};
+
+  dAllocateODEDataForThread(dAllocateMaskAll);
+  dsSetViewpoint (xyz,hpr);
+}
+
+/* simulation loop */
+
+static void simLoop (int pause)
+{
+  int i,j;
+  const dReal* ballPos;
+	const dReal* ksVel;
+	const dReal* ksPos;
+	dReal ksDist;
+  dVector3 anchorPos;
+  dVector3 endPos;
+	dVector3 newVel;
+  static dReal tv = 0;
+  static int reset = 1;
+
+  if (!pause) {
+    /* The stops work much better with smaller time steps */
+    for (i=0;i<16;++i) {
+      dSpaceCollide (space,0,&nearCallback);
+      /* Either stepper seems to work fine. */
+      dWorldStep (world,0.001); 
+      //dWorldQuickStep(world, 0.001);
+
+      /* remove all contact joints */
+      dJointGroupEmpty (contactgroup);
+    }
+    if (reset) {
+      /* Since we create all of the bodies in 
+         unsatisfied states, we kill the momentum 
+         after ERP has fixed that.
+      */
+      
+      for (i=0;i<SNUM;++i) {
+			  dBodySetAngularVel(sphereBody[i],0,0,0);
+			  dBodySetLinearVel(sphereBody[i],0,0,0);
+		  }
+      reset = 0;
+    }
+
+    /* Push the linearly constrained ball around. */
+    tv += M_PI/200;
+    if (tv>=2*M_PI) tv=0;
+    dJointSetLMPlusParam(sJoint[0],dParamVel, dSin(tv)*2 );
+		
+		// Make the sphere wander randomly to shake
+		// the attached bodies around.
+		ksPos = dBodyGetPosition(kSphereBody);
+		ksDist = dCalcPointsDistance3(ksPos,kSphereOrigin);
+		if (ksDist>=1.5) {
+			dSubtractVectors3(newVel,kSphereOrigin,ksPos);
+			dScaleVector3(newVel,0.25/ksDist);
+		} else {
+			ksVel = dBodyGetLinearVel(kSphereBody);
+			for (j=0;j<3;++j) {
+				newVel[j]=ksVel[j] + (dRandReal()-0.5)*0.2;
+			}
+		}
+		dBodySetLinearVel(kSphereBody,newVel[0],newVel[1],newVel[2]);
+  }
+
+  dsSetColor (1,1,0);
+  dsSetTexture (DS_WOOD);
+
+  /* Draw all the balls */
+  for (i=0;i<SNUM;++i) {
+    ballPos = dBodyGetPosition(sphereBody[i]);
+    dJointGetLMPlusAnchor1( sJoint[i], anchorPos );
+    dsDrawLine(ballPos,anchorPos);
+    dsDrawSphere(dBodyGetPosition(sphereBody[i]),dBodyGetRotation(sphereBody[i]),RADIUS);
+  }
+
+  /* Draw the flippers */
+  dsSetColor(1,.5f,0);
+  for (i=0;i<DNUM;++i) {
+    dsDrawBox(dBodyGetPosition(dominoBody[i]),dBodyGetRotation(dominoBody[i]),domDim);
+  }
+
+  /* Draw the planar constraint box. */
+  dsSetColor(0,0,1);
+  dsDrawBox(dBodyGetPosition(planeBody),dBodyGetRotation(planeBody),planeDim);
+
+  /* Draw the constraint line */ 
+  anchorPos[0]=3; endPos[0] = 3;
+  anchorPos[1]=0; endPos[1] = 0;
+  anchorPos[2]=1; endPos[2] = 3;
+  dsDrawLine(anchorPos,endPos);
+
+  /* Draw the volume constraints last because of alpha. */
+  /* Use alpha because they have no geom and the balls
+		 can fall through. */
+  dsSetColorAlpha(0,0,1,.75);
+  dsDrawSphere(dBodyGetPosition(kSphereBody),dBodyGetRotation(kSphereBody),kSphereDim);
+	dsDrawBox(dBodyGetPosition(boxBody),dBodyGetRotation(boxBody),boxDim);
+	dsDrawCylinder(dBodyGetPosition(cylBody),dBodyGetRotation(cylBody),cylDim[0],cylDim[1]);
+}
+
+void command(int c)
+{
+	int ii;
+  switch (c) {
+    case ' ':
+			for (ii=S1NUM+S2NUM+S3NUM+S4NUM;ii<SNUM;++ii) {
+				dBodySetAngularVel(sphereBody[ii],0,0,0);
+				dBodySetLinearVel(sphereBody[ii],0,0,0);
+			}
+      break;
+  }
+}
+
+int main (int argc, char **argv)
+{
+  dMass m;
+  dMatrix3 rMat;
+  int i;
+  dJointID tmpJoint;
+
+  /* setup pointers to drawstuff callback functions */
+  dsFunctions fn;
+  fn.version = DS_VERSION;
+  fn.start = &start;
+  fn.step = &simLoop;
+  fn.command = command;
+  fn.stop = 0;
+  fn.path_to_textures = DRAWSTUFF_TEXTURE_PATH;
+
+  /* create world */
+  dInitODE2(0);
+  world = dWorldCreate();
+  space = dHashSpaceCreate (0);
+  contactgroup = dJointGroupCreate (1000000);
+  dWorldSetGravity (world,0,0,-10);
+  dWorldSetQuickStepNumIterations(world, 50);
+	//dWorldSetMaxAngularSpeed(world,10);
+	//dWorldSetAngularDamping(world,0.001);
+  dCreatePlane (space,0,0,1,0);
+
+	/* Create a kinematic body for the sphere volume constraint. */
+	kSphereBody = dBodyCreate(world);
+	dBodySetKinematic(kSphereBody);
+	dBodySetPosition(kSphereBody,kSphereOrigin[0],kSphereOrigin[1],kSphereOrigin[2]);
+
+	/* Create a kinematic body for the cylinder volume constraint. */
+	cylBody = dBodyCreate(world);
+	dBodySetKinematic(cylBody);
+	dBodySetPosition(cylBody,4,-2,3);
+
+
+  /* Create a kinematic body for the box volume constraint. */
+  boxBody = dBodyCreate(world);
+  dBodySetKinematic(boxBody);
+  /* No geom so objects can fall through. */
+  /*dGeomSetBody(dCreateBox(space,boxDim[0],boxDim[1],boxDim[2]),boxBody);*/
+  dBodySetPosition(boxBody,1,1,3);
+  
+  /* Kinematic body for the plane constraint. */
+  planeBody = dBodyCreate(world);
+  dBodySetKinematic(planeBody);
+  dGeomSetBody(dCreateBox(space,planeDim[0],planeDim[1],planeDim[2]),planeBody);
+  dBodySetPosition(planeBody,-2,-1,3);
+  
+
+  /* Create a couple flippers. */
+  dMassSetBox(&m,DENSITY,domDim[0],domDim[1],domDim[2]);
+  for (i = 0; i<DNUM;++i) {
+    dominoBody[i] = dBodyCreate(world);
+    dBodySetMass(dominoBody[i],&m);
+    dGeomSetBody(dCreateBox(space,domDim[0],domDim[1],domDim[2]),dominoBody[i] );
+    /* Position all of the dominoes as desired. */
+    dBodySetPosition(dominoBody[i],2.6+(i%2)*0.8,0,1+i*0.5);
+    tmpJoint = dJointCreateHinge(world,0);
+    dJointAttach(tmpJoint,dominoBody[i],0);
+    dJointSetHingeAnchor(tmpJoint,2.6+(i%2)*0.8,0,1+i*0.5);
+    dJointSetHingeAxis(tmpJoint,0,1,0);
+    dJointSetHingeParam(tmpJoint,dParamVel,0.75);
+    dJointSetHingeParam(tmpJoint,dParamFMax,75);
+  }
+ 
+  /* Create the balls */
+  dMassSetSphere(&m,DENSITY,RADIUS);
+  for (i = 0; i<SNUM; ++i) {
+    sphereBody[i] = dBodyCreate(world);
+    dBodySetMass(sphereBody[i],&m);
+    dGeomSetBody( dCreateSphere(space,RADIUS), sphereBody[i]);
+
+    
+  }
+
+	int kk=0;
+	/* Assign sphere to the linear constraint.  */
+  for (i = kk; i<(kk+S1NUM); ++i) {
+    sJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach (sJoint[i],sphereBody[i],0);
+    /* Make the constraints relative to the world */
+    dJointSetLMPlusMode(sJoint[i],0,dLMPlusPlanar); 
+		dJointSetLMPlusMode(sJoint[i],1,dLMPlusPlanar); 
+		dJointSetLMPlusMode(sJoint[i],2,dLMPlusPlanar); 
+    dJointSetLMPlusAxis(sJoint[i],0, 0, 0,0,1);
+    dJointSetLMPlusAxis(sJoint[i],1, 0, 1,0,0);
+    dJointSetLMPlusAxis(sJoint[i],2, 0, 0,1,0);
+    /* All axes are limits keeping the ref. point
+       of the ball inside the box. */
+    dJointSetLMPlusAnchor1Rel(sJoint[i],0,0,0.8);
+    dJointSetLMPlusAnchor2Rel(sJoint[i],3,0,2);
+    /* We need a less verbose way of setting the parameters... */    
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop1, -1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop1, 1);
+    dJointSetLMPlusParam(sJoint[i],dParamFMax1, 350 ); /* Turn on the motor. */
+    dJointSetLMPlusParam(sJoint[i],dParamVel1, 0 );
+		dJointSetLMPlusParam(sJoint[i],dParamLoStop2, 0);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop2, 0);
+		dJointSetLMPlusParam(sJoint[i],dParamLoStop3, 0);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop3, 0);
+    
+    dBodySetPosition(sphereBody[i], 3,0,dRandReal()*2+1);
+  }
+	kk+=S1NUM;
+
+	/* Assign some balls to the planar constraint. */
+  for (i = kk; i<(S2NUM+kk); ++i) {
+    sJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach (sJoint[i],sphereBody[i],planeBody);
+    /* Make the constraints relative to the box */
+    dJointSetLMPlusMode(sJoint[i],0,dLMPlusPlanar);
+		dJointSetLMPlusMode(sJoint[i],1,dLMPlusPlanar);
+		dJointSetLMPlusMode(sJoint[i],2,dLMPlusPlanar);
+    dJointSetLMPlusAxis(sJoint[i],0, 2, 0,0,1);
+    dJointSetLMPlusAxis(sJoint[i],1, 2, 1,0,0);
+    dJointSetLMPlusAxis(sJoint[i],2, 2, 0,1,0);
+    
+    dJointSetLMPlusAnchor1Rel(sJoint[i],0,0,0.8);
+    dJointSetLMPlusAnchor2Rel(sJoint[i],0,0,0);
+    /* We need a less verbose way of setting the parameters... */    
+		dJointSetLMPlusParam(sJoint[i],dParamLoStop1, 0);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop1, 0);
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop2,-1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop2, 1);
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop3,-1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop3, 1);
+
+    dBodySetPosition(sphereBody[i],-dRandReal()*2-1,-dRandReal()*2,1);
+  }
+	kk+=S2NUM;
+  
+  /* Assign some spheres to the box volume constraint.
+     We're sloppy with positioning them.  The first
+     few frames of simulation should fix the error. */ 
+  for (i = kk; i<(S3NUM+kk); ++i) {
+    sJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach (sJoint[i],sphereBody[i],boxBody);
+
+		/* Put the constraint in planar mode */
+		dJointSetLMPlusMode(sJoint[i],0,dLMPlusPlanar);
+		dJointSetLMPlusMode(sJoint[i],1,dLMPlusPlanar);
+		dJointSetLMPlusMode(sJoint[i],2,dLMPlusPlanar);
+		/* Make the constraints relative to the box */
+    dJointSetLMPlusAxis(sJoint[i],0, 2, 0,0,1);
+		dJointSetLMPlusAxis(sJoint[i],1, 2, 1,0,0);
+		dJointSetLMPlusAxis(sJoint[i],2, 2, 0,1,0);
+    
+    /* Set the reference points on the two bodies. */
+    dJointSetLMPlusAnchor1Rel(sJoint[i],0,0,0.8);
+		dJointSetLMPlusAnchor2Rel(sJoint[i],0,0,0);
+    
+		/* All axes are limits keeping the ref. point
+       of the ball inside the box. */
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop1,-1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop1, 1);
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop2,-1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop2, 1);
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop3,-1);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop3, 1);
+
+    dBodySetPosition(sphereBody[i],dRandReal()*2,dRandReal()*2,1);
+  }
+	kk+=S3NUM;
+
+	/* Assign some spheres to the cylinder volume constraint. */ 
+  for (i = kk; i<(S4NUM+kk); ++i) {
+    sJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach (sJoint[i],sphereBody[i],cylBody);
+
+		/* Put one constraint in planar mode */
+		dJointSetLMPlusMode(sJoint[i],0,dLMPlusPlanar);
+		/* And one constraint in cylinder mode */
+		dJointSetLMPlusMode(sJoint[i],1,dLMPlusCylindrical);
+		
+		/* Make the constraints relative to the volume */
+    dJointSetLMPlusAxis(sJoint[i],0, 2, 0,0,1);
+		dJointSetLMPlusAxis(sJoint[i],1, 2, 0,0,1);
+    
+    /* Set the reference points on the two bodies. */
+    dJointSetLMPlusAnchor1Rel(sJoint[i],0,0,0.8);
+		dJointSetLMPlusAnchor2Rel(sJoint[i],0,0,0);
+    
+		/* All axes are limits keeping the ref. point
+       of the ball inside the box. */
+    dJointSetLMPlusParam(sJoint[i],dParamLoStop1,-cylDim[0]/2.0);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop1, cylDim[0]/2.0);
+    //dJointSetLMPlusParam(sJoint[i],dParamLoStop2, cylDim[1]/2.0);
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop2, cylDim[1]);
+
+    dBodySetPosition(sphereBody[i],cylOrigin[0]+dRandReal()-0.5,cylOrigin[1]+dRandReal()-0.5,cylOrigin[2]);
+  }
+	kk+=S4NUM;
+
+	/* Assign some balls to the sphere volume constraint. */ 
+  for (i = kk; i<(S5NUM+kk); ++i) {
+    sJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach (sJoint[i],sphereBody[i],kSphereBody);
+
+		/* Put the constraint in planar mode */
+		dJointSetLMPlusMode(sJoint[i],0,dLMPlusSpherical);
+    
+    /* Set the reference points on the two bodies. */
+    dJointSetLMPlusAnchor1Rel(sJoint[i],0,0,0.8);
+		dJointSetLMPlusAnchor2Rel(sJoint[i],0,0,0);
+    
+		/* The joint limit keeps the ref. point
+       of the small balls inside the other ball. */
+    dJointSetLMPlusParam(sJoint[i],dParamHiStop1,kSphereDim);
+		//dJointSetLMPlusParam(sJoint[i],dParamStopCFM,0.00001);
+		dJointSetLMPlusParam(sJoint[i],dParamStopERP,0.1);
+
+		/* Add a motor constraint pulling the points together. */
+		//dJointSetLMPlusParam(sJoint[i],dParamVel,-0.25);
+		//dJointSetLMPlusParam(sJoint[i],dParamFMax,100);
+
+		dBodySetPosition(sphereBody[i],
+			kSphereOrigin[0]+kSphereDim*dCos(2*M_PI/i),
+			kSphereOrigin[1]+kSphereDim*dSin(2*M_PI/i),
+			kSphereOrigin[2]);
+
+  }
+	kk+=S5NUM;
+	
+
+  /* Axes are set in global frame. Make sure the body's not
+     rotated until they're set. */
+  dRFromEulerAngles(rMat,M_PI/4,M_PI/4,0);
+  dBodySetRotation(boxBody,rMat);
+
+
+	dBodySetAngularVel(boxBody,0,1,0.15);
+	dBodySetAngularVel(cylBody,0,.75,0);
+	dBodySetAngularVel(planeBody,.50,0,0.05);
+
+  /* run simulation */
+  dsSimulationLoop (argc,argv,352,288,&fn);
+
+  dJointGroupDestroy (contactgroup);
+  dSpaceDestroy (space);
+  dWorldDestroy (world);
+  dCloseODE();
+  return 0;
+}
Index: ode/demo/Makefile.am
===================================================================
--- ode/demo/Makefile.am	(revision 1903)
+++ ode/demo/Makefile.am	(working copy)
@@ -36,6 +36,8 @@
                 demo_kinematic \
                 demo_motion \
                 demo_motor \
+                demo_amplus \
+                demo_lmplus \
                 demo_ode \
                 demo_piston \
                 demo_plane2d \
@@ -70,6 +72,8 @@
 demo_kinematic_SOURCES = demo_kinematic.cpp
 demo_motion_SOURCES = demo_motion.cpp
 demo_motor_SOURCES = demo_motor.cpp
+demo_amplus_SOURCES = demo_amplus.cpp
+demo_lmplus_SOURCES = demo_lmplus.cpp
 demo_ode_SOURCES = demo_ode.cpp
 demo_piston_SOURCES = demo_piston.cpp
 demo_plane2d_SOURCES = demo_plane2d.cpp
Index: ode/src/export-dif.cpp
===================================================================
--- ode/src/export-dif.cpp	(revision 1903)
+++ ode/src/export-dif.cpp	(working copy)
@@ -163,7 +163,9 @@
         c.print ("motor = {");
     }
     c.indent++;
-    c.printNonzero ("vel",limot.vel);
+    //c.printNonzero ("vel",limot.vel);
+    c.printNonzero ("lo_vel",limot.lo_vel);
+    c.printNonzero ("hi_vel",limot.hi_vel);
     c.printNonzero ("fmax",limot.fmax);
     c.print ("ODE = {");
     c.indent++;
Index: ode/src/joints/amotor.cpp
===================================================================
--- ode/src/joints/amotor.cpp	(revision 1903)
+++ ode/src/joints/amotor.cpp	(working copy)
@@ -184,7 +184,10 @@
 void 
 dxJointAMotor::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = num;
+    info->max_m = 0;
+    for (int i=0;i<num;++i) {
+      info->max_m += limot[i].countSureMaxRows();
+    }
 }
 
 
@@ -205,11 +208,9 @@
     // see if we're powered or at a joint limit for each axis
     for ( int i = 0; i < num; i++ )
     {
-        if ( limot[i].testRotationalLimit( angle[i] ) ||
-            limot[i].fmax > 0 )
-        {
-            info->m++;
-        }
+      limot[i].testRotationalLimit( angle[i] );
+      info->m += limot[i].countRows();
+      info->nub += limot[i].countUBRows();
     }
 }
 
@@ -256,7 +257,7 @@
     int row = 0;
     for ( i = 0; i < num; i++ )
     {
-        row += limot[i].addLimot( this, info, row, *( axptr[i] ), 1 );
+        row += limot[i].addRotationalLimot( this, info, *( axptr[i] ), row );
     }
 }
 
@@ -342,7 +343,7 @@
     if ( joint->mode == dAMotorUser )
     {
         if ( anum < 0 ) anum = 0;
-        if ( anum > 3 ) anum = 3;
+        if ( anum > 2 ) anum = 2;
         joint->angle[anum] = angle;
     }
 }
@@ -438,7 +439,7 @@
     dAASSERT( joint && anum >= 0 && anum < 3 );
     checktype( joint, AMotor );
     if ( anum < 0 ) anum = 0;
-    if ( anum > 3 ) anum = 3;
+    if ( anum > 2 ) anum = 2;
     return joint->angle[anum];
 }
 
